<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.13"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>pam_pkcs11: mapper.h File Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">pam_pkcs11
   &#160;<span id="projectnumber">0.6.11</span>
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.13 -->
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
$(function() {
  initMenu('',false,false,'search.php','Search');
});
</script>
<div id="main-nav"></div>
<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_68267d1309a1af8e8297ef4c3efbcdba.html">src</a></li><li class="navelem"><a class="el" href="dir_29c88563d03148ba4c309ff3e02018c1.html">mappers</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="summary">
<a href="#nested-classes">Data Structures</a> &#124;
<a href="#define-members">Macros</a> &#124;
<a href="#typedef-members">Typedefs</a> &#124;
<a href="#func-members">Functions</a>  </div>
  <div class="headertitle">
<div class="title">mapper.h File Reference</div>  </div>
</div><!--header-->
<div class="contents">
<div class="textblock"><code>#include &lt;sys/types.h&gt;</code><br />
<code>#include &lt;stdlib.h&gt;</code><br />
<code>#include &lt;string.h&gt;</code><br />
<code>#include &lt;pwd.h&gt;</code><br />
<code>#include &lt;<a class="el" href="cert__st_8h_source.html">../common/cert_st.h</a>&gt;</code><br />
<code>#include &quot;<a class="el" href="scconf_8h_source.html">../scconf/scconf.h</a>&quot;</code><br />
</div>
<p><a href="mapper_8h_source.html">Go to the source code of this file.</a></p>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="nested-classes"></a>
Data Structures</h2></td></tr>
<tr class="memitem:"><td class="memItemLeft" align="right" valign="top">struct &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structmapper__module__st.html">mapper_module_st</a></td></tr>
<tr class="memdesc:"><td class="mdescLeft">&#160;</td><td class="mdescRight">Structure to be filled on mapper module initialization.  <a href="structmapper__module__st.html#details">More...</a><br /></td></tr>
<tr class="separator:"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:"><td class="memItemLeft" align="right" valign="top">struct &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structmapfile.html">mapfile</a></td></tr>
<tr class="memdesc:"><td class="mdescLeft">&#160;</td><td class="mdescRight">This struct is used in processing map files a map file is a list of "key" " -&gt; " "value" text lines.  <a href="structmapfile.html#details">More...</a><br /></td></tr>
<tr class="separator:"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="define-members"></a>
Macros</h2></td></tr>
<tr class="memitem:a13bd5c2569e42f48a17ce7d7acd6607b"><td class="memItemLeft" align="right" valign="top">#define&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="mapper_8h.html#a13bd5c2569e42f48a17ce7d7acd6607b">MAPPER_EXTERN</a>&#160;&#160;&#160;extern</td></tr>
<tr class="separator:a13bd5c2569e42f48a17ce7d7acd6607b"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a791f7f44d4bc2b0fb3db279e4f5a8dc0"><td class="memItemLeft" align="right" valign="top">#define&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="mapper_8h.html#a791f7f44d4bc2b0fb3db279e4f5a8dc0">_DEFAULT_MAPPER_FIND_ENTRIES</a></td></tr>
<tr class="memdesc:a791f7f44d4bc2b0fb3db279e4f5a8dc0"><td class="mdescLeft">&#160;</td><td class="mdescRight">Default macro for locate certificate entry.  <a href="#a791f7f44d4bc2b0fb3db279e4f5a8dc0">More...</a><br /></td></tr>
<tr class="separator:a791f7f44d4bc2b0fb3db279e4f5a8dc0"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ac77f111c63b7a5a1c75c81e5937da326"><td class="memItemLeft" align="right" valign="top">#define&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="mapper_8h.html#ac77f111c63b7a5a1c75c81e5937da326">_DEFAULT_MAPPER_FIND_USER</a></td></tr>
<tr class="memdesc:ac77f111c63b7a5a1c75c81e5937da326"><td class="mdescLeft">&#160;</td><td class="mdescRight">Default macro for locating user.  <a href="#ac77f111c63b7a5a1c75c81e5937da326">More...</a><br /></td></tr>
<tr class="separator:ac77f111c63b7a5a1c75c81e5937da326"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ac8058aaca72c3f6db063e5128bf8eab1"><td class="memItemLeft" align="right" valign="top">#define&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="mapper_8h.html#ac8058aaca72c3f6db063e5128bf8eab1">_DEFAULT_MAPPER_MATCH_USER</a></td></tr>
<tr class="memdesc:ac8058aaca72c3f6db063e5128bf8eab1"><td class="mdescLeft">&#160;</td><td class="mdescRight">Macro for match mapper function.  <a href="#ac8058aaca72c3f6db063e5128bf8eab1">More...</a><br /></td></tr>
<tr class="separator:ac8058aaca72c3f6db063e5128bf8eab1"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:afc62f3ec1bd2d9427511f13c525fc610"><td class="memItemLeft" align="right" valign="top">#define&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="mapper_8h.html#afc62f3ec1bd2d9427511f13c525fc610">_DEFAULT_MAPPER_END</a></td></tr>
<tr class="memdesc:afc62f3ec1bd2d9427511f13c525fc610"><td class="mdescLeft">&#160;</td><td class="mdescRight">Macro for de-initialization routine.  <a href="#afc62f3ec1bd2d9427511f13c525fc610">More...</a><br /></td></tr>
<tr class="separator:afc62f3ec1bd2d9427511f13c525fc610"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:adb5e0d438bea160c5f0d35a8cdaf6466"><td class="memItemLeft" align="right" valign="top">#define&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="mapper_8h.html#adb5e0d438bea160c5f0d35a8cdaf6466">_DEFAULT_MAPPER_INIT</a></td></tr>
<tr class="memdesc:adb5e0d438bea160c5f0d35a8cdaf6466"><td class="mdescLeft">&#160;</td><td class="mdescRight">Macro for default init function.  <a href="#adb5e0d438bea160c5f0d35a8cdaf6466">More...</a><br /></td></tr>
<tr class="separator:adb5e0d438bea160c5f0d35a8cdaf6466"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="typedef-members"></a>
Typedefs</h2></td></tr>
<tr class="memitem:a701fdce8eeaa5a0cadca3d947cb838eb"><td class="memItemLeft" align="right" valign="top">typedef struct <a class="el" href="structmapper__module__st.html">mapper_module_st</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="mapper_8h.html#a701fdce8eeaa5a0cadca3d947cb838eb">mapper_module</a></td></tr>
<tr class="memdesc:a701fdce8eeaa5a0cadca3d947cb838eb"><td class="mdescLeft">&#160;</td><td class="mdescRight">Structure to be filled on mapper module initialization.  <a href="#a701fdce8eeaa5a0cadca3d947cb838eb">More...</a><br /></td></tr>
<tr class="separator:a701fdce8eeaa5a0cadca3d947cb838eb"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="func-members"></a>
Functions</h2></td></tr>
<tr class="memitem:abd7e377bfc805aeac08054aa5ece69b9"><td class="memItemLeft" align="right" valign="top"><a class="el" href="mapper_8h.html#a701fdce8eeaa5a0cadca3d947cb838eb">mapper_module</a> *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="mapper_8h.html#abd7e377bfc805aeac08054aa5ece69b9">mapper_module_init</a> (<a class="el" href="scconf_8h.html#aa1a6aa691197930df0da465dabadbc7d">scconf_block</a> *ctx, const char *mapper_name)</td></tr>
<tr class="memdesc:abd7e377bfc805aeac08054aa5ece69b9"><td class="mdescLeft">&#160;</td><td class="mdescRight">Initialize module and <a class="el" href="structmapper__module__st.html" title="Structure to be filled on mapper module initialization. ">mapper_module_st</a> structure.  <a href="#abd7e377bfc805aeac08054aa5ece69b9">More...</a><br /></td></tr>
<tr class="separator:abd7e377bfc805aeac08054aa5ece69b9"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aff785dc94718a428e1ef46c35dc2dcfa"><td class="memItemLeft" align="right" valign="top"><a class="el" href="mapper_8h.html#a13bd5c2569e42f48a17ce7d7acd6607b">MAPPER_EXTERN</a> struct <a class="el" href="structmapfile.html">mapfile</a> *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="mapper_8h.html#aff785dc94718a428e1ef46c35dc2dcfa">set_mapent</a> (const char *uri)</td></tr>
<tr class="memdesc:aff785dc94718a428e1ef46c35dc2dcfa"><td class="mdescLeft">&#160;</td><td class="mdescRight">Initialize a mapper entry table.  <a href="#aff785dc94718a428e1ef46c35dc2dcfa">More...</a><br /></td></tr>
<tr class="separator:aff785dc94718a428e1ef46c35dc2dcfa"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a1478d4be0cc248ad061a36339c9b3daf"><td class="memItemLeft" align="right" valign="top"><a class="el" href="mapper_8h.html#a13bd5c2569e42f48a17ce7d7acd6607b">MAPPER_EXTERN</a> int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="mapper_8h.html#a1478d4be0cc248ad061a36339c9b3daf">get_mapent</a> (struct <a class="el" href="structmapfile.html">mapfile</a> *mfile)</td></tr>
<tr class="memdesc:a1478d4be0cc248ad061a36339c9b3daf"><td class="mdescLeft">&#160;</td><td class="mdescRight">Retrieve next entry of given map file.  <a href="#a1478d4be0cc248ad061a36339c9b3daf">More...</a><br /></td></tr>
<tr class="separator:a1478d4be0cc248ad061a36339c9b3daf"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:abab71f0630103ff957b9e5d84a6105c0"><td class="memItemLeft" align="right" valign="top"><a class="el" href="mapper_8h.html#a13bd5c2569e42f48a17ce7d7acd6607b">MAPPER_EXTERN</a> void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="mapper_8h.html#abab71f0630103ff957b9e5d84a6105c0">end_mapent</a> (struct <a class="el" href="structmapfile.html">mapfile</a> *mfile)</td></tr>
<tr class="memdesc:abab71f0630103ff957b9e5d84a6105c0"><td class="mdescLeft">&#160;</td><td class="mdescRight">Release a mapentry structure.  <a href="#abab71f0630103ff957b9e5d84a6105c0">More...</a><br /></td></tr>
<tr class="separator:abab71f0630103ff957b9e5d84a6105c0"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a3d5d44cc12d4710ab83cd61ced1e6a2f"><td class="memItemLeft" align="right" valign="top"><a class="el" href="mapper_8h.html#a13bd5c2569e42f48a17ce7d7acd6607b">MAPPER_EXTERN</a> char *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="mapper_8h.html#a3d5d44cc12d4710ab83cd61ced1e6a2f">mapfile_find</a> (const char *file, char *key, int ignorecase, int *match)</td></tr>
<tr class="memdesc:a3d5d44cc12d4710ab83cd61ced1e6a2f"><td class="mdescLeft">&#160;</td><td class="mdescRight">Try to map "key" to provided mapfile.  <a href="#a3d5d44cc12d4710ab83cd61ced1e6a2f">More...</a><br /></td></tr>
<tr class="separator:a3d5d44cc12d4710ab83cd61ced1e6a2f"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a589ef6dd1c494a11afb251acec024d85"><td class="memItemLeft" align="right" valign="top"><a class="el" href="mapper_8h.html#a13bd5c2569e42f48a17ce7d7acd6607b">MAPPER_EXTERN</a> int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="mapper_8h.html#a589ef6dd1c494a11afb251acec024d85">mapfile_match</a> (const char *file, char *key, const char *value, int ignorecase)</td></tr>
<tr class="memdesc:a589ef6dd1c494a11afb251acec024d85"><td class="mdescLeft">&#160;</td><td class="mdescRight">Try to match provided key to provided name by mean of a mapfile.  <a href="#a589ef6dd1c494a11afb251acec024d85">More...</a><br /></td></tr>
<tr class="separator:a589ef6dd1c494a11afb251acec024d85"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a11277748d021c9212e7460b90e10749c"><td class="memItemLeft" align="right" valign="top"><a class="el" href="mapper_8h.html#a13bd5c2569e42f48a17ce7d7acd6607b">MAPPER_EXTERN</a> char *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="mapper_8h.html#a11277748d021c9212e7460b90e10749c">search_pw_entry</a> (const char *item, int ignorecase)</td></tr>
<tr class="memdesc:a11277748d021c9212e7460b90e10749c"><td class="mdescLeft">&#160;</td><td class="mdescRight">find the user login that matches pw_name or pw_gecos with provided item  <a href="#a11277748d021c9212e7460b90e10749c">More...</a><br /></td></tr>
<tr class="separator:a11277748d021c9212e7460b90e10749c"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a21892c500d029efa93208fd716de48c3"><td class="memItemLeft" align="right" valign="top"><a class="el" href="mapper_8h.html#a13bd5c2569e42f48a17ce7d7acd6607b">MAPPER_EXTERN</a> int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="mapper_8h.html#a21892c500d029efa93208fd716de48c3">compare_pw_entry</a> (const char *item, struct passwd *pw, int ignorecase)</td></tr>
<tr class="memdesc:a21892c500d029efa93208fd716de48c3"><td class="mdescLeft">&#160;</td><td class="mdescRight">Test if provided item matches pw_name or pw_gecos of provided password structure.  <a href="#a21892c500d029efa93208fd716de48c3">More...</a><br /></td></tr>
<tr class="separator:a21892c500d029efa93208fd716de48c3"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<h2 class="groupheader">Macro Definition Documentation</h2>
<a id="afc62f3ec1bd2d9427511f13c525fc610"></a>
<h2 class="memtitle"><span class="permalink"><a href="#afc62f3ec1bd2d9427511f13c525fc610">&#9670;&nbsp;</a></span>_DEFAULT_MAPPER_END</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">#define _DEFAULT_MAPPER_END</td>
        </tr>
      </table>
</div><div class="memdoc">
<b>Value:</b><div class="fragment"><div class="line"><span class="keyword">static</span> <span class="keywordtype">void</span> mapper_module_end(<span class="keywordtype">void</span> *context) {                          \</div><div class="line">        free(context);                                                  \</div><div class="line">        return;                                                         \</div><div class="line">}                                                                       \</div></div><!-- fragment -->
<p>Macro for de-initialization routine. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">context</td><td>Mapper context </td></tr>
  </table>
  </dd>
</dl>

<p class="definition">Definition at line <a class="el" href="mapper_8h_source.html#l00219">219</a> of file <a class="el" href="mapper_8h_source.html">mapper.h</a>.</p>

</div>
</div>
<a id="a791f7f44d4bc2b0fb3db279e4f5a8dc0"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a791f7f44d4bc2b0fb3db279e4f5a8dc0">&#9670;&nbsp;</a></span>_DEFAULT_MAPPER_FIND_ENTRIES</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">#define _DEFAULT_MAPPER_FIND_ENTRIES</td>
        </tr>
      </table>
</div><div class="memdoc">
<b>Value:</b><div class="fragment"><div class="line"><span class="keyword">static</span> <span class="keywordtype">char</span> ** mapper_find_entries(X509 *x509, <span class="keywordtype">void</span> *context) {         \</div><div class="line">        return NULL;                                                    \</div><div class="line">}</div></div><!-- fragment -->
<p>Default macro for locate certificate entry. </p>
<p>Provided as sample for debugging, not for real user </p><dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">x509</td><td>X509 Certificate </td></tr>
    <tr><td class="paramname">context</td><td>Mapper context </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>String array with up to 15 results or NULL if fail </dd></dl>

<p class="definition">Definition at line <a class="el" href="mapper_8h_source.html#l00174">174</a> of file <a class="el" href="mapper_8h_source.html">mapper.h</a>.</p>

</div>
</div>
<a id="ac77f111c63b7a5a1c75c81e5937da326"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ac77f111c63b7a5a1c75c81e5937da326">&#9670;&nbsp;</a></span>_DEFAULT_MAPPER_FIND_USER</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">#define _DEFAULT_MAPPER_FIND_USER</td>
        </tr>
      </table>
</div><div class="memdoc">
<b>Value:</b><div class="fragment"><div class="line"><span class="keyword">static</span> <span class="keywordtype">char</span> * mapper_find_user(X509 *x509,<span class="keywordtype">void</span> *context,<span class="keywordtype">int</span> *match) {           \</div><div class="line">        if ( !x509 ) <span class="keywordflow">return</span> NULL;                                       \</div><div class="line">        *match = 1;                                                     \</div><div class="line">        return <span class="stringliteral">&quot;nobody&quot;</span>;                                                \</div><div class="line">}</div></div><!-- fragment -->
<p>Default macro for locating user. </p>
<p>Should not be used except for debugging, as always returns "nobody" </p><dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">x509</td><td>X509 Certificate </td></tr>
    <tr><td class="paramname">context</td><td>Mapper context </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>Found user, or NULL </dd></dl>

<p class="definition">Definition at line <a class="el" href="mapper_8h_source.html#l00187">187</a> of file <a class="el" href="mapper_8h_source.html">mapper.h</a>.</p>

</div>
</div>
<a id="adb5e0d438bea160c5f0d35a8cdaf6466"></a>
<h2 class="memtitle"><span class="permalink"><a href="#adb5e0d438bea160c5f0d35a8cdaf6466">&#9670;&nbsp;</a></span>_DEFAULT_MAPPER_INIT</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">#define _DEFAULT_MAPPER_INIT</td>
        </tr>
      </table>
</div><div class="memdoc">
<b>Value:</b><div class="fragment"><div class="line"><a class="code" href="structmapper__module__st.html">mapper_module</a>* <a class="code" href="mapper_8h.html#abd7e377bfc805aeac08054aa5ece69b9">mapper_module_init</a>(<a class="code" href="struct__scconf__block.html">scconf_block</a> *blk,<span class="keyword">const</span> <span class="keywordtype">char</span> *name) { \</div><div class="line">        mapper_module *pt= malloc(<span class="keyword">sizeof</span> (<a class="code" href="structmapper__module__st.html">mapper_module</a>));              \</div><div class="line">        if (!pt) <span class="keywordflow">return</span> NULL;                                           \</div><div class="line">        pt-&gt;name    = name;                                             \</div><div class="line">        pt-&gt;context = NULL;                                             \</div><div class="line">        pt-&gt;block   = blk;                                              \</div><div class="line">        pt-&gt;dbg_level  = <a class="code" href="debug_8h.html#a0a71da33384f6806f93542b4cb95d7d2">get_debug_level</a>();                             \</div><div class="line">        pt-&gt;entries = mapper_find_entries;                              \</div><div class="line">        pt-&gt;finder  = mapper_find_user;                                 \</div><div class="line">        pt-&gt;matcher = mapper_match_user;                                \</div><div class="line">        pt-&gt;deinit  = mapper_module_end;                        \</div><div class="line">        return pt;                                                      \</div><div class="line">}                                                                       \</div><div class="ttc" id="mapper_8h_html_abd7e377bfc805aeac08054aa5ece69b9"><div class="ttname"><a href="mapper_8h.html#abd7e377bfc805aeac08054aa5ece69b9">mapper_module_init</a></div><div class="ttdeci">mapper_module * mapper_module_init(scconf_block *ctx, const char *mapper_name)</div><div class="ttdoc">Initialize module and mapper_module_st structure. </div></div>
<div class="ttc" id="structmapper__module__st_html"><div class="ttname"><a href="structmapper__module__st.html">mapper_module_st</a></div><div class="ttdoc">Structure to be filled on mapper module initialization. </div><div class="ttdef"><b>Definition:</b> <a href="mapper_8h_source.html#l00040">mapper.h:40</a></div></div>
<div class="ttc" id="debug_8h_html_a0a71da33384f6806f93542b4cb95d7d2"><div class="ttname"><a href="debug_8h.html#a0a71da33384f6806f93542b4cb95d7d2">get_debug_level</a></div><div class="ttdeci">DEBUG_EXTERN int get_debug_level(void)</div><div class="ttdoc">get_debug_level() Returns the current debug level. </div></div>
<div class="ttc" id="struct__scconf__block_html"><div class="ttname"><a href="struct__scconf__block.html">_scconf_block</a></div><div class="ttdef"><b>Definition:</b> <a href="scconf_8h_source.html#l00077">scconf.h:77</a></div></div>
</div><!-- fragment -->
<p>Macro for default init function. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">blk</td><td>Mapper Configuration file block </td></tr>
    <tr><td class="paramname">name</td><td>Name of this mapper </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>pointer to mapper_module data, else NULL NOTE: mapper module data MUST BE defined in module </dd></dl>

<p class="definition">Definition at line <a class="el" href="mapper_8h_source.html#l00232">232</a> of file <a class="el" href="mapper_8h_source.html">mapper.h</a>.</p>

</div>
</div>
<a id="ac8058aaca72c3f6db063e5128bf8eab1"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ac8058aaca72c3f6db063e5128bf8eab1">&#9670;&nbsp;</a></span>_DEFAULT_MAPPER_MATCH_USER</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">#define _DEFAULT_MAPPER_MATCH_USER</td>
        </tr>
      </table>
</div><div class="memdoc">
<b>Value:</b><div class="fragment"><div class="line"><span class="keyword">static</span> <span class="keywordtype">int</span> mapper_match_user(X509 *x509, <span class="keyword">const</span> <span class="keywordtype">char</span> *login, <span class="keywordtype">void</span> *context) { \</div><div class="line">        int match = 0;                                                  \</div><div class="line">        char *username= mapper_find_user(x509,context,&amp;match);          \</div><div class="line">        if (!x509) <span class="keywordflow">return</span> -1;                                           \</div><div class="line">        if (!login) <span class="keywordflow">return</span> -1;                                          \</div><div class="line">        if (!username) <span class="keywordflow">return</span> 0; <span class="comment">/*user not found*/</span>                     \</div><div class="line">        if ( ! strcmp(login,username) ) <span class="keywordflow">return</span> 1; <span class="comment">/* match user */</span>      \</div><div class="line">        return 0; <span class="comment">/* no match */</span>                                        \</div><div class="line">}</div></div><!-- fragment -->
<p>Macro for match mapper function. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">x509</td><td>X509 Certificate </td></tr>
    <tr><td class="paramname">login</td><td>user to match, or null to find user that matches certificate </td></tr>
    <tr><td class="paramname">context</td><td>Mapper context </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>1 on success; login points to matched user 0 on no match -1 on error </dd></dl>

<p class="definition">Definition at line <a class="el" href="mapper_8h_source.html#l00204">204</a> of file <a class="el" href="mapper_8h_source.html">mapper.h</a>.</p>

</div>
</div>
<a id="a13bd5c2569e42f48a17ce7d7acd6607b"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a13bd5c2569e42f48a17ce7d7acd6607b">&#9670;&nbsp;</a></span>MAPPER_EXTERN</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">#define MAPPER_EXTERN&#160;&#160;&#160;extern</td>
        </tr>
      </table>
</div><div class="memdoc">

<p class="definition">Definition at line <a class="el" href="mapper_8h_source.html#l00096">96</a> of file <a class="el" href="mapper_8h_source.html">mapper.h</a>.</p>

</div>
</div>
<h2 class="groupheader">Typedef Documentation</h2>
<a id="a701fdce8eeaa5a0cadca3d947cb838eb"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a701fdce8eeaa5a0cadca3d947cb838eb">&#9670;&nbsp;</a></span>mapper_module</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">typedef struct <a class="el" href="structmapper__module__st.html">mapper_module_st</a>  <a class="el" href="mapper_8h.html#a701fdce8eeaa5a0cadca3d947cb838eb">mapper_module</a></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Structure to be filled on mapper module initialization. </p>

</div>
</div>
<h2 class="groupheader">Function Documentation</h2>
<a id="a21892c500d029efa93208fd716de48c3"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a21892c500d029efa93208fd716de48c3">&#9670;&nbsp;</a></span>compare_pw_entry()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="mapper_8h.html#a13bd5c2569e42f48a17ce7d7acd6607b">MAPPER_EXTERN</a> int compare_pw_entry </td>
          <td>(</td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname"><em>item</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">struct passwd *&#160;</td>
          <td class="paramname"><em>pw</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>ignorecase</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Test if provided item matches pw_name or pw_gecos of provided password structure. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">item</td><td>String to be compared </td></tr>
    <tr><td class="paramname">pw</td><td>password entry to search into </td></tr>
    <tr><td class="paramname">ignorecase</td><td>Flag to check upper/lowercase in string comparisions </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>1 on match, 0 on no match, -1 on error </dd></dl>

</div>
</div>
<a id="abab71f0630103ff957b9e5d84a6105c0"></a>
<h2 class="memtitle"><span class="permalink"><a href="#abab71f0630103ff957b9e5d84a6105c0">&#9670;&nbsp;</a></span>end_mapent()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="mapper_8h.html#a13bd5c2569e42f48a17ce7d7acd6607b">MAPPER_EXTERN</a> void end_mapent </td>
          <td>(</td>
          <td class="paramtype">struct <a class="el" href="structmapfile.html">mapfile</a> *&#160;</td>
          <td class="paramname"><em>mfile</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Release a mapentry structure. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">mfile</td><td>Map file structure to be released </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a id="a1478d4be0cc248ad061a36339c9b3daf"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a1478d4be0cc248ad061a36339c9b3daf">&#9670;&nbsp;</a></span>get_mapent()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="mapper_8h.html#a13bd5c2569e42f48a17ce7d7acd6607b">MAPPER_EXTERN</a> int get_mapent </td>
          <td>(</td>
          <td class="paramtype">struct <a class="el" href="structmapfile.html">mapfile</a> *&#160;</td>
          <td class="paramname"><em>mfile</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Retrieve next entry of given map file. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">mfile</td><td>Map file entry pointer </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>1 on sucess, 0 on no more entries, -1 on error </dd></dl>

</div>
</div>
<a id="a3d5d44cc12d4710ab83cd61ced1e6a2f"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a3d5d44cc12d4710ab83cd61ced1e6a2f">&#9670;&nbsp;</a></span>mapfile_find()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="mapper_8h.html#a13bd5c2569e42f48a17ce7d7acd6607b">MAPPER_EXTERN</a> char* mapfile_find </td>
          <td>(</td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname"><em>file</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">char *&#160;</td>
          <td class="paramname"><em>key</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>ignorecase</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int *&#160;</td>
          <td class="paramname"><em>match</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Try to map "key" to provided mapfile. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">file</td><td>URL of map file </td></tr>
    <tr><td class="paramname">key</td><td>String to be mapped </td></tr>
    <tr><td class="paramname">ignorecase</td><td>Flag to indicate upper/lowercase ignore in string compare </td></tr>
    <tr><td class="paramname">match</td><td>Set to 1 for mapped string return, unmodified for key return </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>key on no match, else a <a class="el" href="strings_8h.html#a371a8cb3e3e24b794a5a871fff24242e" title="Duplicate a string. ">clone_str()</a>'d of found mapping </dd></dl>

</div>
</div>
<a id="a589ef6dd1c494a11afb251acec024d85"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a589ef6dd1c494a11afb251acec024d85">&#9670;&nbsp;</a></span>mapfile_match()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="mapper_8h.html#a13bd5c2569e42f48a17ce7d7acd6607b">MAPPER_EXTERN</a> int mapfile_match </td>
          <td>(</td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname"><em>file</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">char *&#160;</td>
          <td class="paramname"><em>key</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname"><em>value</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>ignorecase</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Try to match provided key to provided name by mean of a mapfile. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">file</td><td>URL of map file </td></tr>
    <tr><td class="paramname">key</td><td>String to be mapped </td></tr>
    <tr><td class="paramname">value</td><td>String to be matched against mapped result </td></tr>
    <tr><td class="paramname">ignorecase</td><td>Flag to indicate upper/lowercase ignore in string compare </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>1 on match, 0 on no match, -1 on process error </dd></dl>

</div>
</div>
<a id="abd7e377bfc805aeac08054aa5ece69b9"></a>
<h2 class="memtitle"><span class="permalink"><a href="#abd7e377bfc805aeac08054aa5ece69b9">&#9670;&nbsp;</a></span>mapper_module_init()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="mapper_8h.html#a701fdce8eeaa5a0cadca3d947cb838eb">mapper_module</a>* mapper_module_init </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="scconf_8h.html#aa1a6aa691197930df0da465dabadbc7d">scconf_block</a> *&#160;</td>
          <td class="paramname"><em>ctx</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname"><em>mapper_name</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Initialize module and <a class="el" href="structmapper__module__st.html" title="Structure to be filled on mapper module initialization. ">mapper_module_st</a> structure. </p>
<p>EVERY mapper module MUST provide and export this function if dinamycally linked </p><dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">ctx</td><td>Pointer to related configuration file context </td></tr>
    <tr><td class="paramname">mapper_name</td><td>Name of this mapper. Used for multi-mapper modules </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>Pointer to a mapper_module structure, or NULL if failed </dd></dl>

</div>
</div>
<a id="a11277748d021c9212e7460b90e10749c"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a11277748d021c9212e7460b90e10749c">&#9670;&nbsp;</a></span>search_pw_entry()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="mapper_8h.html#a13bd5c2569e42f48a17ce7d7acd6607b">MAPPER_EXTERN</a> char* search_pw_entry </td>
          <td>(</td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname"><em>item</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>ignorecase</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>find the user login that matches pw_name or pw_gecos with provided item </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">item</td><td>Data to be searched from password database </td></tr>
    <tr><td class="paramname">ignorecase</td><td>Flag to check upper/lowercase in string comparisions </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>userlogin if match found, else NULL </dd></dl>

</div>
</div>
<a id="aff785dc94718a428e1ef46c35dc2dcfa"></a>
<h2 class="memtitle"><span class="permalink"><a href="#aff785dc94718a428e1ef46c35dc2dcfa">&#9670;&nbsp;</a></span>set_mapent()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="mapper_8h.html#a13bd5c2569e42f48a17ce7d7acd6607b">MAPPER_EXTERN</a> struct <a class="el" href="structmapfile.html">mapfile</a>* set_mapent </td>
          <td>(</td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname"><em>uri</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Initialize a mapper entry table. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">uri</td><td>Universal Resource Locator of the file to be mapped </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>A mapfile structure pointer or NULL </dd></dl>

</div>
</div>
</div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated on Wed May 22 2019 12:09:34 for pam_pkcs11 by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.13
</small></address>
</body>
</html>
